]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- skip any formatting for commented out items in format_requires
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
cd445739
AM
1#!/bin/sh
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
7304d35c 25V 0.13 (C) 1999-2005 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
40UPDATE=""
41UPDATE5=""
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
64BCOND=""
65GROUP_BCONDS="no"
947025e5 66CVSIGNORE_DF="no"
d287305c 67
68PATCHES=""
69SOURCES=""
cd445739 70ICONS=""
d287305c 71PACKAGE_RELEASE=""
72PACKAGE_VERSION=""
73PACKAGE_NAME=""
cd445739
AM
74PROTOCOL="ftp"
75WGET_RETRIES=${MAX_WGET_RETRIES:-0}
76CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
77
78CVSTAG=""
79RES_FILE=""
80
81CVS_SERVER="cvs.pld-linux.org"
82DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 83ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 84
36d03934 85DEF_NICE_LEVEL=19
cd445739
AM
86
87FAIL_IF_NO_SOURCES="yes"
88
ab4a2b6e
ER
89if [ -x /usr/bin/rpm-getdeps ]; then
90 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
91else
92 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
93fi
94
cd445739
AM
95# Here we load saved user environment used to
96# predefine options set above, or passed to builder
97# in command line.
98# This one reads global system environment settings:
99if [ -f ~/etc/builderrc ]; then
100 . ~/etc/builderrc
101fi
102# And this one cascades settings using user personal
103# builder settings.
104# Example of ~/.builderrc:
105#
106#UPDATE_POLDEK_INDEXES="yes"
107#FETCH_BUILD_REQUIRES="yes"
108#REMOVE_BUILD_REQUIRES="force"
109#GROUP_BCONDS="yes"
110#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
111#
a83e5405 112SU_SUDO=""
cd445739
AM
113if [ -n "$HOME_ETC" ]; then
114 USER_CFG="$HOME_ETC/.builderrc"
115else
116 USER_CFG=~/.builderrc
117fi
118
119[ -f "$USER_CFG" ] && . "$USER_CFG"
120
06f3864d
AM
121wget --help 2>&1 | grep -q ' \-\-no-check\-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
122
ca2e6c31 123if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
124 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
125 GETURI2="$GETURI"
126 OUTFILEOPT="-O"
ca2e6c31 127elif [ -n "$USE_AXEL" ]; then
cede92b3 128 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
129 GETURI2="$GETURI"
130 OUTFILEOPT="-o"
ca2e6c31 131else
7e365483
KK
132 wget --help 2>&1 | grep -q ' \-\-inet ' && WGET_OPTS="$WGET_OPTS --inet"
133 wget --help 2>&1 | grep -q ' \-\-retry\-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 134
7e365483
KK
135 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
136 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
137 OUTFILEOPT="-O"
2bc5451f 138fi
11468b23 139
11468b23
AM
140GETLOCAL="cp -a"
141
142if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
143 RPM="rpm"
144 RPMBUILD="rpm"
145else
146 RPM="rpm"
147 RPMBUILD="rpmbuild"
148fi
149
150POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 151POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 152
cd445739
AM
153run_poldek()
154{
155 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
156 if [ -n "$LOGFILE" ]; then
157 LOG=`eval echo $LOGFILE`
158 if [ -n "$LASTLOG_FILE" ]; then
159 echo "LASTLOG=$LOG" > $LASTLOG_FILE
160 fi
040282bb 161 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
162 return $exit_pldk
163 else
164 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
165 return `cat ${RES_FILE}`
166 rm -rf ${RES_FILE}
167 fi
168}
169
cd445739
AM
170#---------------------------------------------
171# functions
da946cd6 172
5a491465 173usage()
174{
cd445739
AM
175 if [ -n "$DEBUG" ]; then set -xv; fi
176 echo "\
177Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
81f85806 178
cd445739
AM
179[-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
180[{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>] [-g|--get]
181[-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
182[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
183[-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
184[-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
185[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
dfe2cb9a 186[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--show-bconds]
cd445739 187[--with/--without <feature>] [--define <macro> <value>] <package>[.spec]
2a5f078d 188
cd445739
AM
189-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
190-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
191-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
192-D, --debug - enable builder script debugging mode,
193-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
194-V, --version - output builder version
195-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
196-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
197 from <package>.spec,
198-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
199 only package from <package>.spec,
c56807e0
ER
200-bp, --build-prep - execute the %prep phase of <package>.spec,
201-bc - reserved (not implemented)
202-bi reserved (not implemented)
cd445739
AM
203-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
204 them into src.rpm,
c56807e0 205--short-circuit - reserved (not implemented)
cd445739
AM
206-B, --branch - add branch
207-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
208 SPECS and \$RPM_BUILD_ROOT),
2a5f078d 209-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
210 - setup \$CVSROOT,
211--define <macro> <value>
212 - define a macro <macro> with value <value>,
213--nodeps - rpm won't check any dependences
214-g, --get - get <package>.spec and all related files from CVS repo
215 or HTTP/FTP,
216-h, --help - this message,
217--http - use http instead of ftp,
218-l <logfile>, --logtofile <logfile>
219 - log all to file,
220-m, --mr-proper - only remove all files related to spec file and all work
221 resources,
222-nc, --no-cvs - don't download sources from CVS, if source URL is given,
223-ncs, --no-cvs-specs
224 - don't check specs in CVS
225-nd, --no-distfiles - don't download from distfiles
226-nm, --no-mirrors - don't download from mirror, if source URL is given,
227-nu, --no-urls - don't try to download from FTP/HTTP location,
228-ns, --no-srcs - don't download Sources
229-ns0, --no-source0 - don't download Source0
230-nn, --no-net - don't download anything from the net
231--opts <rpm opts> - additional options for rpm
232-q, --quiet - be quiet,
233--date yyyy-mm-dd - build package using resources from specified CVS date,
234-r <cvstag>, --cvstag <cvstag>
235 - build package using resources from specified CVS tag,
236-R, --fetch-build-requires
237 - fetch what is BuildRequired,
238-RB, --remove-build-requires
239 - remove all you fetched with -R or --fetch-build-requires
240 remember, this option requires confirmation,
241-FRB, --force-remove-build-requires
242 - remove all you fetched with -R or --fetch-build-requires
243 remember, this option works without confirmation,
a7eefc54 244-sf, --source-files - list sources - bare filenames (intended for offline
245 operations; does not work when Icon field is present
246 but icon file is absent),
247-sp, --source-paths - list sources - filenames with full local paths (intended for
248 offline operations; does not work when Icon field is present
249 but icon file is absent),
2dddf439
ER
250-su, --source-urls - list urls - urls to sources and patches
251 intended for copying urls with spec with lots of macros in urls
cd445739
AM
252-T <cvstag> , --tag <cvstag>
253 - add cvs tag <cvstag> for files,
254-Tvs, --tag-version-stable
094bd95b 255 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 256-Tvn, --tag-version-nest
1691a37b 257 - add cvs tags NEST and NAME-VERSION-RELEASE for files,
cd445739
AM
258-Ts, --tag-stable
259 - add cvs tag STABLE for files,
260-Tn, --tag-nest
261 - add cvs tag NEST for files,
262-Tv, --tag-version
1691a37b 263 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
264-Tp, --tag-prefix <prefix>
265 - add <prefix> to NAME-VERSION-RELEASE tags,
266-tt, --test-tag <prefix>
267 - fail if tag is already present,
50321881
JK
268-ir, --integer-release-only
269 - allow only integer and snapshot releases
cd445739
AM
270-v, --verbose - be verbose,
271-u, --try-upgrade - check version, and try to upgrade package
272-un, --try-upgrade-with-float-version
273 - as above, but allow float version
deccc50e 274-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
275-Upi, --update-poldek-indexes
276 - refresh or make poldek package index files.
c890b916 277-np, --nopatch <patchnumber>
bed98670 278 - don't apply <patchnumber>
dfe2cb9a
MK
279--show-bconds - show available conditional builds, which can be used
280 - with --with and/or --without switches.
cd445739
AM
281--with/--without <feature>
282 - conditional build package depending on %_with_<feature>/
283 %_without_<feature> macro switch. You may now use
284 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
285 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 286--target <platform>, --target=<platform>
64ea5308 287 - build for platform <platform>.
5a491465 288"
289}
290
c890b916 291update_shell_title() {
a0d6396b 292 [ -t 1 ] || return
2dddf439 293 echo >&2 "$*"
2e5be021 294 local msg="builder[$SPECFILE] $*"
c890b916
ER
295 case "$TERM" in
296 cygwin|xterm*)
2dddf439 297 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
c890b916
ER
298 ;;
299 screen*)
2dddf439 300 echo >&2 -ne "\033]0;$msg\007"
c890b916
ER
301 ;;
302 esac
303}
304
7e40520f
ER
305# set TARGET from BuildArch: from SPECFILE
306set_spec_target() {
307 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
308 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
309 if [ "$tmp" ]; then
310 TARGET="$tmp"
311 case "$RPMBUILD" in
312 "rpmbuild")
313 TARGET_SWITCH="--target $TARGET" ;;
314 "rpm")
315 TARGET_SWITCH="--target=$TARGET" ;;
316 esac
317 fi
318 fi
319}
320
cd445739 321cache_rpm_dump () {
b2aeec7d
AM
322 if [ -n "$DEBUG" ]; then
323 set -x;
324 set -v;
325 fi
7e40520f 326
cd445739
AM
327rpm_dump_cache=`
328 case "$RPMBUILD" in
329 rpm )
2a5f078d 330 rpm -bp --nodeps --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
331 ;;
332 rpmbuild )
2f810e46 333 rpmbuild --nodigest --nosignature --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
334 ;;
335 esac`
336}
337
338rpm_dump () {
339 if [ -z "$rpm_dump_cache" ] ; then
340 echo "internal error: cache_rpm_dump not called!" 1>&2
341 fi
342 echo "$rpm_dump_cache"
343}
344
59398507 345parse_spec()
346{
2e5be021 347 update_shell_title "parse_spec"
cd445739
AM
348 if [ -n "$DEBUG" ]; then
349 set -x;
350 set -v;
351 fi
b2975fc3 352
cd445739 353 cd $SPECS_DIR
4ca52257 354
cd445739 355 cache_rpm_dump
00fcec7e 356
cd445739
AM
357 if [ "$NOSRCS" != "yes" ]; then
358 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
359 fi
360 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
361 FAIL_IF_NO_SOURCES="no"
362 fi
363
364 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
365 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
366 PACKAGE_NAME="`$RPM -q --qf '%{NAME}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
367 PACKAGE_VERSION="`$RPM -q --qf '%{VERSION}\n' --specfile ${SPECFILE} 2> /dev/null| head -n 1`"
368 PACKAGE_RELEASE="`$RPM -q --qf '%{RELEASE}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
369
341603cf 370# These variables may be unset after first cache_rpm_dump call
371# (because of not-yet-retrieved icon file)
372#
373# if [ -z "$PACKAGE_NAME" -o -z "$PACKAGE_VERSION" -o -z "$PACKAGE_RELEASE" ]; then
374# Exit_error err_no_package_data;
375# fi
78eab2a1 376
cd445739
AM
377 if [ -n "$BE_VERBOSE" ]; then
378 echo "- Sources : `nourl $SOURCES`"
379 if [ -n "$PATCHES" ]; then
380 echo "- Patches : `nourl $PATCHES`"
381 else
382 echo "- Patches : *no patches needed*"
383 fi
384 if [ -n "$ICONS" ]; then
385 echo "- Icon : `nourl $ICONS`"
386 else
387 echo "- Icon : *no package icon*"
388 fi
389 echo "- Name : $PACKAGE_NAME"
390 echo "- Version : $PACKAGE_VERSION"
391 echo "- Release : $PACKAGE_RELEASE"
392 fi
393}
394
395Exit_error()
396{
397 if [ -n "$DEBUG" ]; then
398 set -x;
399 set -v;
400 fi
401
402 cd "$__PWD"
403
404 case "$1" in
405 "err_no_spec_in_cmdl" )
406 remove_build_requires
407 echo "ERROR: spec file name not specified.";
408 exit 2 ;;
409 "err_no_spec_in_repo" )
410 remove_build_requires
411 echo "Error: spec file not stored in CVS repo.";
412 exit 3 ;;
413 "err_no_source_in_repo" )
414 remove_build_requires
415 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)";
416 exit 4 ;;
417 "err_build_fail" )
418 remove_build_requires
419 echo "Error: package build failed. (${2:-no more info})";
420 exit 5 ;;
78eab2a1
AM
421 "err_no_package_data" )
422 remove_build_requires
423 echo "Error: couldn't get out package name/version/release from spec file."
424 exit 6 ;;
50321881
JK
425 "err_tag_exists" )
426 remove_build_requires
427 echo "Tag ${2} already exists (spec release: ${3}).";
428 exit 9 ;;
429 "err_fract_rel" )
430 remove_build_requires
431 echo "Release ${2} not integer and not a snapshot.";
432 exit 10 ;;
fb96e0b5
AM
433 "err_branch_exists" )
434 remove_build_requires
435 echo "Tree branch already exists (${2}).";
436 exit 11 ;;
50321881 437
cd445739 438 esac
50321881 439 echo "Unknown error."
2a5f078d 440 exit 100
cd445739
AM
441}
442
443init_builder()
444{
445 if [ -n "$DEBUG" ]; then
446 set -x;
447 set -v;
0dd6320d 448 fi
cd445739
AM
449
450 SOURCE_DIR="`$RPM --eval '%{_sourcedir}'`"
451 SPECS_DIR="`$RPM --eval '%{_specdir}'`"
452
453 __PWD="`pwd`"
00fcec7e 454}
455
d6a77ddb 456get_spec()
1471f6d6 457{
c890b916 458
2e5be021 459 update_shell_title "get_spec"
c890b916 460
cd445739
AM
461 if [ -n "$DEBUG" ]; then
462 set -x;
463 set -v;
464 fi
465
466 cd "$SPECS_DIR"
467 if [ \! -f "$SPECFILE" ]; then
468 SPECFILE="`basename $SPECFILE .spec`.spec";
469 fi
470 if [ "$NOCVSSPEC" != "yes" ]; then
471 OPTIONS="up "
472
473 if [ -n "$CVSROOT" ]; then
474 OPTIONS="-d $CVSROOT $OPTIONS"
475 else
476 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
477 echo "warning: No cvs access defined - using local .spec file"
478 NOCVSSPEC="yes"
479 fi
480 fi
481
482 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
483 OPTIONS="$OPTIONS -A"
484 else
485 if [ -n "$CVSDATE" ]; then
486 OPTIONS="$OPTIONS -D $CVSDATE"
487 fi
488 if [ -n "$CVSTAG" ]; then
489 OPTIONS="$OPTIONS -r $CVSTAG"
490 fi
491 fi
492
493 result=1
494 retries_counter=0
495 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]
496 do
497 retries_counter=$(( $retries_counter + 1 ))
498 output=$(LC_ALL=C cvs $OPTIONS $SPECFILE 2>&1)
499 result=$?
500 [ -n "$output" ] && echo "$output"
501 if [ "$result" -ne "0" ]; then
502 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$retries_counter" -le "$CVS_RETRIES" ]; then
503 echo "Trying again [$SPECFILE]... ($retries_counter)"
504 sleep 2
505 continue
506 fi
507 Exit_error err_no_spec_in_repo;
508 fi
509 done
510 fi
511 if [ ! -f "$SPECFILE" ]; then
512 Exit_error err_no_spec_in_repo;
513 fi
514
515 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
516 chmod $CHMOD_MODE $SPECFILE
517 fi
518 unset OPTIONS
a7eefc54 519 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f
ER
520
521 set_spec_target
cd445739
AM
522}
523
524find_mirror()
525{
526 cd "$SPECS_DIR"
527 url="$1"
528 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
529 cvs update mirrors >&2
530 fi
531
532 IFS="|"
533 while read origin mirror name rest
534 do
535 ol=`echo -n "$origin"|wc -c`
536 prefix="`echo -n "$url" | head -c $ol`"
537 if [ "$prefix" = "$origin" ] ; then
538 suffix="`echo "$url"|cut -b $ol-`"
539 echo -n "$mirror$suffix"
540 return 0
541 fi
542 done < mirrors
543 echo "$url"
544}
545
546src_no ()
547{
548 cd $SPECS_DIR
549 rpm_dump | \
550 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
551 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
552 head -n 1 | xargs
1471f6d6 553}
554
cd445739 555src_md5 ()
8ba5cdda 556{
cd445739
AM
557 [ X"$NO5" = X"yes" ] && return
558 no=$(src_no "$1")
559 [ -z "$no" ] && return
560 cd $SPECS_DIR
47a8df12 561 spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
cd445739
AM
562 if [ -z "$spec_rev" ]; then
563 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
564 fi
565 spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
566 md5=$(grep -s -v '^#' additional-md5sums | \
567 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
568 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
569 grep -E '^[0-9a-f]{32}$')
570 if [ X"$md5" = X"" ] ; then
6203ea52
AG
571 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
572 if [ ! -z "$source_md5" ] ; then
7e365483 573 echo $source_md5;
6203ea52 574 else
7e365483
KK
575 # we have empty SourceX-md5, but it is still possible
576 # that we have NoSourceX-md5 AND NoSource: X
577 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
578 if [ ! -z "$nosource_md5" -a ! X"`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" = X"" ] ; then
579 echo $nosource_md5;
580 fi;
6203ea52 581 fi;
cd445739
AM
582 else
583 if [ $(echo "$md5" | wc -l) != 1 ] ; then
584 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
585 fi
586 echo "$md5" | tail -n 1
587 fi
588}
589
590distfiles_url ()
591{
1246dc2a 592 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
593}
594
595distfiles_attic_url ()
596{
1246dc2a 597 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
598}
599
600good_md5 ()
601{
602 md5=$(src_md5 "$1")
603 [ "$md5" = "" ] || \
604 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
605}
606
a4b50627
AF
607good_size ()
608{
deccc50e
AM
609 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
610 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
611}
612
947025e5 613cvsignore_df ()
614{
615 if [ "$CVSIGNORE_DF" != "yes" ]; then
616 return
617 fi
618 cvsignore=${SOURCE_DIR}/.cvsignore
619 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
620 echo "$1" >> $cvsignore
621 fi
622}
623
cd445739
AM
624get_files()
625{
626 GET_FILES="$@"
28fac57a 627 update_shell_title "get_files"
cd445739
AM
628
629 if [ -n "$DEBUG" ]; then
630 set -x;
631 set -v;
632 fi
633
634 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
635 cd "$SOURCE_DIR"
636
637 OPTIONS="up "
638 if [ -n "$CVSROOT" ]; then
639 OPTIONS="-d $CVSROOT $OPTIONS"
640 else
641 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
642 echo "warning: No cvs access defined for SOURCES"
643 NOCVS="yes"
644 fi
645 fi
646 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
647 OPTIONS="$OPTIONS -A"
648 else
649 if [ -n "$CVSDATE" ]; then
650 OPTIONS="$OPTIONS -D $CVSDATE"
651 fi
652 if [ -n "$CVSTAG" ]; then
653 OPTIONS="$OPTIONS -r $CVSTAG"
654 fi
655 fi
656 for i in $GET_FILES
657 do
658 if [ -n "$UPDATE5" ]; then
659 if [ -n "$ADD5" ]; then
660 [ `nourl $i` = "$i" ] && continue
661 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
662 else
663 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
664 fi
665 fi
666 FROM_DISTFILES=0
667 if [ ! -f `nourl $i` ] || [ $ALWAYS_CVSUP = "yes" ]; then
668 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
669 echo "Warning: no URL given for $i"
670 fi
671
672 if [ -n "$(src_md5 "$i")" ] && [ -z "$NODIST" ]; then
a4b50627 673 if good_md5 "$i" && good_size "$i"; then
deccc50e 674 echo "$(nourl "$i") having proper md5sum already exists"
cd445739
AM
675 continue
676 fi
677 target=$(nourl "$i")
678 url=$(distfiles_url "$i")
679 url_attic=$(distfiles_attic_url "$i")
680 FROM_DISTFILES=1
33da77c4 681 if [ "`echo $url | grep -E '^(\.|/)'`" ]; then
2e5be021 682 update_shell_title "get_files: $url"
cd445739
AM
683 ${GETLOCAL} $url $target
684 else
685 if [ -z "$NOMIRRORS" ]; then
686 url="`find_mirror "$url"`"
687 fi
2e5be021 688 update_shell_title "get_files: $url"
ca2e6c31 689 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 690 if [ "`echo $url | grep -E 'ftp://'`" ]; then
2e5be021 691 update_shell_title "get_files: $url"
ca2e6c31 692 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
693 fi
694 fi
695 if ! test -s "$target"; then
696 rm -f "$target"
697 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
2e5be021 698 update_shell_title "get_files: $url_attic"
cd445739
AM
699 ${GETLOCAL} $url_attic $target
700 else
701 if [ -z "$NOMIRRORS" ]; then
702 url_attic="`find_mirror "$url_attic"`"
703 fi
2e5be021 704 update_shell_title "get_files: $url_attic"
ca2e6c31 705 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 706 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
2e5be021 707 update_shell_title "get_files: $url_attic"
ca2e6c31 708 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
709 fi
710 fi
711 fi
947025e5 712 if test -s "$target"; then
713 cvsignore_df $target
714 else
cd445739
AM
715 rm -f "$target"
716 FROM_DISTFILES=0
717 fi
718 elif [ -z "$(src_md5 "$i")" -a "$NOCVS" != "yes" ]; then
719 # ( echo $i | grep -qvE '(ftp|http|https)://' ); -- if CVS should be used, but URLs preferred
720 result=1
721 retries_counter=0
722 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]
723 do
724 retries_counter=$(( $retries_counter + 1 ))
725 output=$(LC_ALL=C cvs $OPTIONS `nourl $i` 2>&1)
726 result=$?
727 [ -n "$output" ] && echo "$output"
728 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
729 echo "Trying again [`nourl $i`]... ($retries_counter)"
730 sleep 2
731 continue
732 else
733 break
734 fi
735 done
736 fi
737
33da77c4 738 if [ -z "$NOURLS" ] && [ ! -f "`nourl $i`" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
739 if [ -z "$NOMIRRORS" ]; then
740 im="`find_mirror "$i"`"
741 else
742 im="$i"
743 fi
2e5be021 744 update_shell_title "get_files: $im"
cd445739 745 ${GETURI} "$im" || \
33da77c4 746 if [ "`echo $im | grep -E 'ftp://'`" ]; then
2e5be021 747 update_shell_title "get_files: $im"
cd445739 748 ${GETURI2} "$im"
7e365483 749 fi
cd445739
AM
750 fi
751
752 fi
753 srcno=$(src_no $i)
754 if [ ! -f "`nourl $i`" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
755 Exit_error err_no_source_in_repo $i;
756 elif [ -n "$UPDATE5" ] && \
757 ( ( [ -n "$ADD5" ] && echo $i | grep -q -E 'ftp://|http://|https://' && \
758 [ -z "$(grep -E -i '^NoSource[ ]*:[ ]*'$i'([ ]|$)' $SPECS_DIR/$SPECFILE)" ] ) || \
759 grep -q -i -E '^#[ ]*source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
760 then
deccc50e 761 echo "Updating source-$srcno md5."
cd445739
AM
762 md5=$(md5sum `nourl $i` | cut -f1 -d' ')
763 perl -i -ne '
deccc50e
AM
764 print unless /^\s*#\s*Source'$srcno'-md5\s*:/i;
765 print "# Source'$srcno'-md5:\t'$md5'\n"
cd445739
AM
766 if /^Source'$srcno'\s*:\s+/;
767 ' \
768 $SPECS_DIR/$SPECFILE
769 fi
2a5f078d 770
a4b50627 771 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
772 :
773 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 774 # wrong md5 from distfiles: remove the file and try again
cd445739 775 # but only once ...
deccc50e 776 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
777 FROM_DISTFILES=2
778 rm -f $target
2e5be021 779 update_shell_title "get_files: $url"
ca2e6c31 780 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 781 if [ "`echo $url | grep -E 'ftp://'`" ]; then
2e5be021 782 update_shell_title "get_files: $url"
ca2e6c31 783 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
784 fi
785 if ! test -s "$target"; then
786 rm -f "$target"
2e5be021 787 update_shell_title "get_files: $url_attic"
ca2e6c31 788 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 789 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
2e5be021 790 update_shell_title "get_files: $url_attic"
ca2e6c31 791 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
792 fi
793 fi
794 test -s "$target" || rm -f "$target"
795 fi
796
a4b50627 797 if good_md5 "$i" && good_size "$i" ; then
cd445739
AM
798 :
799 else
deccc50e
AM
800 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
801 echo "or -5 to update md5 sums, if you're sure files are correct."
cd445739
AM
802 Exit_error err_no_source_in_repo $i
803 fi
804 done
805
806 if [ "$CHMOD" = "yes" ]; then
807 CHMOD_FILES="`nourl $GET_FILES`"
808 if [ -n "$CHMOD_FILES" ]; then
809 chmod $CHMOD_MODE $CHMOD_FILES
810 fi
811 fi
812 unset OPTIONS
813 fi
814}
815
816make_tagver() {
78eab2a1
AM
817
818 if [ -n "$DEBUG" ]; then
819 set -x;
820 set -v;
821 fi
2a5f078d 822
cd445739
AM
823 # Check whether first character of PACKAGE_NAME is legal for tag name
824 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
825 TAG_PREFIX=tag_
826 fi
827 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
828 # Remove #kernel.version_release from TAGVER because tagging sources
829 # could occur with different kernel-headers than kernel-headers used at build time.
830 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
831 echo -n "$TAGVER"
832}
833
834tag_files()
835{
836 TAG_FILES="$@"
837
838 if [ -n "$DEBUG" ]; then
839 set -x;
840 set -v;
841 fi
842
843 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
844 echo "Version: $PACKAGE_VERSION"
845 echo "Release: $PACKAGE_RELEASE"
846
847 TAGVER=`make_tagver`
848
849 if [ "$TAG_VERSION" = "yes" ]; then
850 echo "CVS tag: $TAGVER"
851 fi
852 if [ -n "$TAG" ]; then
853 echo "CVS tag: $TAG"
854 fi
855
856 OPTIONS="tag -F"
857 if [ -n "$CVSROOT" ]; then
858 OPTIONS="-d $CVSROOT $OPTIONS"
859 fi
860
861 cd "$SOURCE_DIR"
862 for i in $TAG_FILES
863 do
864 # don't tag files stored on distfiles
865 [ -n "`src_md5 $i`" ] && continue
866 if [ -f "`nourl $i`" ]; then
867 if [ "$TAG_VERSION" = "yes" ]; then
868 cvs $OPTIONS $TAGVER `nourl $i`
869 fi
870 if [ -n "$TAG" ]; then
871 cvs $OPTIONS $TAG `nourl $i`
872 fi
873 else
874 Exit_error err_no_source_in_repo $i
875 fi
876 done
877
878 cd "$SPECS_DIR"
879 if [ "$TAG_VERSION" = "yes" ]; then
880 cvs $OPTIONS $TAGVER $SPECFILE
881 fi
882 if [ -n "$TAG" ]; then
883 cvs $OPTIONS $TAG $SPECFILE
884 fi
885
886 unset OPTIONS
887 fi
888}
889
890branch_files()
891{
892 TAG=$1
893 echo "CVS branch tag: $TAG"
894 shift;
895
896 TAG_FILES="$@"
897
898 if [ -n "$DEBUG" ]; then
899 set -x;
900 set -v;
901 fi
902
903 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
904
905 OPTIONS="tag -b"
906 if [ -n "$CVSROOT" ]; then
907 OPTIONS="-d $CVSROOT $OPTIONS"
908 fi
909 cd "$SOURCE_DIR"
910 for i in $TAG_FILES
911 do
912 if [ -f `nourl $i` ]; then
913 cvs $OPTIONS $TAG `nourl $i`
914 else
915 Exit_error err_no_source_in_repo $i
916 fi
917 done
918 cd "$SPECS_DIR"
919 cvs $OPTIONS $TAG $SPECFILE
920
921 unset OPTIONS
922 fi
923}
924
925
926
59398507 927build_package()
928{
2e5be021 929 update_shell_title "build_package"
cd445739
AM
930 if [ -n "$DEBUG" ]; then
931 set -x;
932 set -v;
933 fi
5a491465 934
cd445739
AM
935 cd "$SPECS_DIR"
936
937 if [ -n "$TRY_UPGRADE" ]; then
2e5be021 938 update_shell_title "build_package: try_upgrade"
cd445739 939 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 940 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 941 else
cc538c24 942 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
943 fi
944
945 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
946
947 if [ -n "$TNEWVER" ]; then
948 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
949 echo "New version found, updating spec file to version " $TNEWVER
950 cp -f $SPECFILE $SPECFILE.bak
951 chmod +w $SPECFILE
952 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 953 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
cd445739 954 parse_spec;
7f347798 955 if [ -n "$ICONS" ]; then
956 get_files $ICONS;
957 parse_spec;
958 fi
f7b91886 959 NODIST="yes" UPDATE5="yes" get_files "$SOURCES $PATCHES";
cd445739
AM
960 unset TOLDVER TNEWVER TNOTIFY
961 fi
962 fi
963 cd "$SPECS_DIR"
2a5f078d 964
cd445739
AM
965 case "$COMMAND" in
966 build )
967 BUILD_SWITCH="-ba" ;;
968 build-binary )
969 BUILD_SWITCH="-bb" ;;
970 build-source )
971 BUILD_SWITCH="-bs --nodeps" ;;
972 build-prep )
973 BUILD_SWITCH="-bp --nodeps" ;;
974 esac
c890b916 975
2e5be021 976 update_shell_title "build_package: $COMMAND"
cd445739
AM
977 if [ -n "$LOGFILE" ]; then
978 LOG=`eval echo $LOGFILE`
979 if [ -d "$LOG" ]; then
980 echo "Log file $LOG is a directory."
981 echo "Parse error in the spec?"
982 Exit_error err_build_fail;
983 fi
984 if [ -n "$LASTLOG_FILE" ]; then
985 echo "LASTLOG=$LOG" > $LASTLOG_FILE
986 fi
987 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
21bc1a97 988 (time eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
989 RETVAL=`cat $RES_FILE`
990 rm $RES_FILE
991 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
992 if [ "$RETVAL" -eq "0" ]; then
993 mv $LOG $LOGDIROK
994 else
995 mv $LOG $LOGDIRFAIL
996 fi
997 fi
8ba5cdda 998 else
8f96ab6c 999 eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 1000 RETVAL=$?
8ba5cdda 1001 fi
cd445739
AM
1002 if [ "$RETVAL" -ne "0" ]; then
1003 if [ -n "$TRY_UPGRADE" ]; then
1004 echo "\n!!! Package with new version cannot be build automagically\n"
1005 mv -f $SPECFILE.bak $SPECFILE
1006 fi
1007 Exit_error err_build_fail;
1008 fi
1009 unset BUILD_SWITCH
1010}
1011
1012nourl()
1013{
1014 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1015}
1016
cd445739
AM
1017install_required_packages()
1018{
1019 run_poldek -vi $1
1020 return $?
1021}
1022
1023set_bconds_values()
1024{
2e5be021 1025 update_shell_title "set_bconds_values"
c890b916 1026
cd445739
AM
1027 AVAIL_BCONDS_WITHOUT=""
1028 AVAIL_BCONDS_WITH=""
1029 if `grep -q ^%bcond ${SPECFILE}`; then
1030 BCOND_VERSION="NEW"
36d03934 1031 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
cd445739
AM
1032 BCOND_VERSION="OLD"
1033 else
1034 BCOND_VERSION="NONE"
1035 fi
301cbfd4
ER
1036
1037 # expand bconds from ~/.bcondrc
1038 # The file structure is like gentoo's package.use:
1039 # ---
1040 # * -selinux
1041 # samba -mysql -pgsql
47a8df12 1042 # w32codec-installer license_agreement
301cbfd4
ER
1043 # php +mysqli
1044 # ---
c8a3e2ac 1045 if [ "${BCOND_VERSION}" != "NONE" ] && ( [ -f $HOME/.bcondrc ] || ( [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] ) ) ; then
301cbfd4
ER
1046 # This takes package name, first defined in spec.
1047 # so consider that when defining flags for package.
1048 PN=`$RPM -q --qf '%{NAME}\n' --specfile $SPECFILE | head -n 1`
3e1cbfe0 1049 SN=${SPECFILE%%\.spec}
301cbfd4
ER
1050 AVAIL=`$RPMBUILD --bcond $SPECFILE`
1051
c8a3e2ac
AG
1052 BCONDRC=$HOME/.bcondrc
1053 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && BCONDRC=$HOME_ETC/.bcondrc
1054
301cbfd4
ER
1055 while read pkg flags; do
1056 # ignore comments
1057 [[ "$pkg" == \#* ]] && continue
1058
1059 # any package or current package?
3e1cbfe0 1060 if [ "$pkg" = "*" ] || [ "$pkg" = "$PN" ] || [ "$pkg" = "$SN" ]; then
301cbfd4
ER
1061 for flag in $flags; do
1062 opt=${flag#[+-]}
1063
1064 # use only flags which are in this package.
1065 if [[ $AVAIL = *${opt}* ]]; then
3b5101f0
ER
1066 if [[ $flag = -* ]]; then
1067 BCOND="$BCOND --without $opt"
301cbfd4 1068 else
3b5101f0 1069 BCOND="$BCOND --with $opt"
301cbfd4
ER
1070 fi
1071 fi
1072 done
1073 fi
c8a3e2ac 1074 done < $BCONDRC
301cbfd4
ER
1075 fi
1076
cd445739
AM
1077 case "${BCOND_VERSION}" in
1078 NONE)
7e365483 1079 :
cd445739 1080 ;;
7e365483 1081 OLD)
cd445739
AM
1082 echo "Warning: This spec has old style bconds. Fix it || die."
1083 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_without_`
1084 do
1085 AVAIL_BCOND_WITHOUT=`echo $opt|sed -e "s/^_without_//g"`
1086 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1087 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1088 else
1089 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1090 fi
1091 done
2a5f078d 1092
cd445739
AM
1093 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_with_`
1094 do
1095 AVAIL_BCOND_WITH=`echo $opt|sed -e "s/^_with_//g"`
1096 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1097 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1098 else
1099 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1100 fi
1101 done
1102 ;;
1103 NEW)
1104 cond_type="" # with || without
1105 for opt in `$RPMBUILD --bcond $SPECFILE`
1106 do
1107 case "$opt" in
1108 _without)
1109 cond_type="without"
1110 ;;
1111 _with)
1112 cond_type="with"
1113 ;;
f8d24cee 1114 _without_*)
1115 AVAIL_BCOND_WITHOUT="`echo $opt | sed 's/^_without_//g'`"
1116 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1117 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1118 else
1119 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1120 fi
1121 ;;
1122 _with_*)
1123 AVAIL_BCOND_WITH="`echo $opt | sed 's/^_with_//g'`"
1124 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1125 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1126 else
1127 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1128 fi
1129 ;;
cd445739
AM
1130 *)
1131 case "$cond_type" in
1132 with)
1133 cond_type=''
1134 AVAIL_BCOND_WITH="$opt"
1135 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1136 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1137 else
1138 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1139 fi
7e365483 1140 ;;
cd445739
AM
1141 without)
1142 cond_type=''
1143 AVAIL_BCOND_WITHOUT="$opt"
1144 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1145 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1146 else
1147 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1148 fi
1149 ;;
1150 esac
1151 ;;
1152 esac
1153 done
1154 ;;
1155 esac
1156}
1157
1158run_sub_builder()
1159{
1160 package_name="${1}"
af6b168f 1161 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1162 #
1163